<template>
  <Teleport v-if="modalState.isOpen" to="#modals">
        <div class="modal-content modal-top-left">
          <div class="modal-header">
            <h5 class="modal-title">{{ modalState.title }}</h5>
            <button @click="closeModal" type="button" class="btn-close" data-dismiss="modal" aria-label="Close" />
          </div>
          <div class="modal-body">
            <p v-if="modalState.type === 'permaLink'">{{ modalState.content }}</p>
            <section v-else-if="modalState.type === 'legend'">
              <section v-if="modalState.content.length > 0">
                <div class="accordion accordion-flush" id="accordionExample">
                  <div v-for="layer in modalState.content" class="accordion-item">
                    <h2 class="accordion-header" :id="'heading-' + layer.id">
                      <button class="accordion-button" :class="modalState.content.length > 1 ? 'collapsed' : ''" type="button" data-bs-toggle="collapse" :data-bs-target="'#collapse-' + layer.id" aria-expanded="false" :aria-controls="'collapse-'+layer.id">
                        {{ layer.name }}
                      </button>
                    </h2>
                    <div :id="'collapse-' + layer.id" class="accordion-collapse collapse" :class="modalState.content.length > 1 ? '' : 'show'" :aria-labelledby="'heading-' + layer.id" data-bs-parent="#accordionExample">
                      <div class="accordion-body">
                        <p class="layer-description">{{ layer.description }}</p>
                        <div class="geojson-legend-wrapper" v-if="layer.type === 'geojson'">
                          <div :style="'background-color:' + layer.color + ';'" class="geojson-legend" />
                          <span>{{ layer.name }}</span>
                        </div>
                        <img v-else-if="layer.type === 'wms'" :src="layer.imgURL" :alt="layer.name">
                        <img v-else-if="layer.type === 'raster'" src="/static/RasterLegend.png" :alt="layer.name">
                      </div>
                    </div>
                  </div>
                </div>
              </section>
              <p v-else>Aucune couche selectionnée</p>
            </section>
            <section v-else-if="modalState.type === 'graph-methods'">
              <p>
                <b>Origine mesures:</b> Mesures faites par le laboratoire de la Société Walonne des Eaux (SWDE).<br />
                Ces mesures sont faites sur l’eau prélevée, cette eau n’est pas distribuée si les normes de potabilité sont dépassées. <br />
                <br />
                <b>Lissage lowess:</b> Obtenu avec la fonction lowess de la libraire Python ‘statsmodels’. <br />
                La fenêtre flottante utilisée pour calculer les valeurs lissées est le minimum entre 5 années et deux tiers de la longueur totale de la série temporelle. <br />
                <br />
                <b>Tendances:</b> Les points de rupture (=les points où les tendances changent) sont calculés en utilisant le package Python ‘ruptures’. <br />
                La fonction de coût à minimiser est ‘CostCLinear’ et l’algorithme de recherche est ‘Dynamic programming’. <br />
                Le nombre de points de ruptures est défini en minimisant le BIC, et un minimum de 5 ans est requis entre chaque point de rupture.
                Les tendances entre les points de rupture sont ensuite calculées avec l’estimateur de Theil-Sen. <br />
                Les flèches dans le panneau de gauche indiquent une pente de tendance seulement si la tendance est significative. La ou les dates écrites entre les flèches indiquent le moment du point de rupture. <br />
                <br />
                <b>La norme:</b> <br />
                • <i>Pour les nitrates:</i> Norme de potabilité définie par l’Organisation Mondiale de la Santé (OMS). <br />
                • <i>Pour les pesticides:</i> Norme de potabilité définie par la directive européenne 98/83/CE. <br />
                • <i>Pas de norme pour la turbidité.</i>
              </p>
            </section>
            <section v-else-if="modalState.type === 'station-landuse'">
              <StationLandUseContent/>
            </section>
            <section v-else-if="modalState.type === 'info-files'">
              <InfoFileContent/>
            </section>
          </div>
        </div>
  </Teleport>
</template>

<script lang="ts">
import {defineComponent, computed} from 'vue'
import { useStore } from '@/store'
import StationLandUseContent from './StationLandUseContent.vue'
import InfoFileContent from './InfoFileContent.vue'
import {ContentLegend} from "@/utils/_types";

export default defineComponent({
  name: 'Modal',
  components: { StationLandUseContent, InfoFileContent },
  setup: () => {
    const store = useStore();

    const closeModal = () => {
      store.commit('setModalState', {
        isOpen: !store.state.modalState.isOpen,
        type: null,
        content: ''
      })
    }

/*    const getLegendColor = (l: ContentLegend) => {
      return l.
    }*/

    return {
      modalState: computed(() => store.state.modalState),
      closeModal,
      // getLegendColor
    }
  }
})
</script>
<style lang="scss" scoped>
.geojson-legend-wrapper {
  display: flex;
  span {
    line-height: 15px;
  }
  div.geojson-legend {
    width: 15px;
    height: 15px;
    margin-right: 1rem;
  }
}
</style>
